package inf101.v18.rogue101.map;

import inf101.v18.gfx.gfxmode.ITurtle;
import inf101.v18.gfx.textmode.Printer;
import inf101.v18.grid.Location;
import inf101.v18.rogue101.object.Item;

import java.util.List;

/**
 * Extra map methods that are for the game class only!
 *
 * @author anya
 */
public interface GameMap extends MapView {

    /**
     * Draw the map
     *
     * @param painter
     * @param printer
     */
    void draw(ITurtle painter, Printer printer);

    /**
     * Get a modifiable list of items
     *
     * @param loc
     * @return
     */
    List<Item> getAllModifiable(Location loc);

    /**
     * Remove any destroyed items at the given location (items where {@link Item#isDestroyed()} is true)
     *
     * @param loc
     */
    void clean(Location loc);

    /**
     * Remove an item
     *
     * @param loc
     * @param item
     */
    void remove(Location loc, Item item);

}
