package inf101.v18.rogue101.object;

import inf101.v18.rogue101.game.Game;

/**
 * An actor controlled by the computer
 *
 * @author anya
 */
public interface NonPlayerCharacter extends Actor {

    /**
     * Do one turn for this non-player
     * <p>
     * This INonPlayer will be the game's current actor ({@link Game#getActor()})
     * for the duration of this method call.
     *
     * @param game Game, for interacting with the world
     */
    void doTurn(Game game);

}
