package inf101.v18.rogue101.state;

import java.util.Random;

/**
 * The occupation of an enemy, which decides the type of attack it uses
 */
public enum Occupation {

    /**
     * A knight that always uses melee attacks
     */
    KNIGHT,

    /**
     * A mage that always uses magic attacks
     */
    MAGE,

    /**
     * An archer that always uses ranged attacks
     */
    ARCHER;

    private static final Random random = new Random();

    public static Occupation getRandom() {
        return values()[random.nextInt(values().length)];
    }

}
