package inf101.v18.util;

import java.util.Random;

/**
 * An interface for generators of random data values (to be used in testing).
 *
 * @param <T> The type of data generated.
 */
public interface Generator<T> {

    /**
     * Generate a random object.
     *
     * @return An object of type T
     */
    T generate();

    /**
     * Generate a random object.
     *
     * @param r A random generator
     * @return An object of type T
     */
    T generate(Random r);

}
