package inf101.v18.util.generators;

import inf101.v18.grid.IArea;
import inf101.v18.grid.Location;

import java.util.Random;

public class LocationGenerator extends AbstractGenerator<Location> {
    private final IArea area;

    /**
     * New LocationGenerator, will generate locations within the area
     */
    public LocationGenerator(IArea area) {
        this.area = area;
    }

    @Override
    public Location generate(Random r) {
        return area.location(r.nextInt(area.getWidth()), r.nextInt(area.getHeight()));
    }

}
